/*
** Der umstlpbare Wrfel nach Paul Schatz
** (C) 1999 Franz Zahaurek <http://www.fzk.at>
**
** Dieses Programm samt Dokumentation ist Freie Software und kann beliebig
** verwendet werden, soferne der obige Copyright-Vermerk nicht entfernt
** wird.
*/
/* $Id: wdrucke.c,v 1.3 2004/03/14 19:20:40 fzk Exp $ */

#include <config.h>
#include <math.h>
#include <stdio.h>
#include "wuerfel.h"

/* Koordinaten der Eckpunkte des Wuerfelgrtels ausgeben

   Folgende Files werden erstellt:

   Macro          Wert                   Inhalt
   FILE2D(i1, i2) "daten2d"#i1#i2".dat"  2D, Projektion in Ebene x/y, x/z, y/z
   FILE3D         "daten3d.dat"          3D, Werte aller Punkte im Raum
   FILESEGS       "datensegs.dat"        3D, jeweils die Ecken aller Kanten
*/
/*
#define PRINT2D(i1, i2, f,n) (fprintf (f##i1##i2, "%f %f\n", \
				       twgp->wgp.e[n-1].i1, \
				       twgp->wgp.e[n-1].i2))
*/
/*
#define PRINT3D(f,n) (fprintf (f, "%f %f %f\n", twgp->wgp.e[n-1].x, \
                                                twgp->wgp.e[n-1].y, \
						twgp->wgp.e[n-1].z))
*/
/*
#define PRINTSEGS(f,x,k) fprintf (f, "%f %f %f\n%f %f %f\n", \
        twgp->wgp.e[(x[k-1].von)-1].x, \
        twgp->wgp.e[(x[k-1].von)-1].y, \
        twgp->wgp.e[(x[k-1].von)-1].z, \
        twgp->wgp.e[(x[k-1].nach)-1].x, \
	twgp->wgp.e[(x[k-1].nach)-1].y, \
	twgp->wgp.e[(x[k-1].nach)-1].z);
*/
#define PRINT2D(i1, i2, f,n) fprintf (f##i1##i2, "%f %f\n", \
				       twgp->S(n,i1), \
				       twgp->S(n,i2));
#define PRINT3D(f,n) fprintf (f, "%f %f %f\n", twgp->S(n,x), \
                                               twgp->S(n,y), \
		       			       twgp->S(n,z));
#define PRINTSEGS(f,k,i) fprintf (f, "%f %f %f\n%f %f %f\n", \
        twgp->wgp.e[(k[i-1].von)-1].x, \
        twgp->wgp.e[(k[i-1].von)-1].y, \
        twgp->wgp.e[(k[i-1].von)-1].z, \
        twgp->wgp.e[(k[i-1].nach)-1].x, \
	twgp->wgp.e[(k[i-1].nach)-1].y, \
	twgp->wgp.e[(k[i-1].nach)-1].z);

void
printwg(void) {
    WG *twgp;
    int i, j;
    FILE *f2dxy;
    FILE *f2dxz;
    FILE *f2dyz;
    FILE *f3d;
    FILE *fsegs;
    FILE *foloid;

    if (! options.print) {
	return;
    }

    f2dxy = fopen (FILE2D(x, y), "w"); /* Files werden ueberschrieben,
					      wenn sie bereits existieren */
    f2dxz = fopen (FILE2D(x, z), "w");
    f2dyz = fopen (FILE2D(y, z), "w");
    f3d   = fopen (FILE3D, "w");
    fsegs = fopen (FILESEGS, "w");
    foloid= fopen (FILEOLOID, "w");

    for(twgp=wg; twgp->nextwgp != (WG *)NULL; twgp=twgp->nextwgp) {
	fprintf (f2dxy, "# Position bei Winkel %7.3f\n", GWINKEL(twgp->wgp.w));
	fprintf (f2dxz, "# Position bei Winkel %7.3f\n", GWINKEL(twgp->wgp.w));
	fprintf (f2dyz, "# Position bei Winkel %7.3f\n", GWINKEL(twgp->wgp.w));
	fprintf (f3d,   "# Position bei Winkel %7.3f\n", GWINKEL(twgp->wgp.w));
	fprintf (fsegs, "# Position bei Winkel %7.3f\n", GWINKEL(twgp->wgp.w));
	fprintf (foloid,"# Position bei Winkel %7.3f\n", GWINKEL(twgp->wgp.w));

	/*
	** nur die obere Hlfte des WG wird ausgegeben
	*/
	for (i=1; i<=8; i++) {
	    PRINT2D (x, y, f2d, i);
	    PRINT2D (x, z, f2d, i);
	    PRINT2D (y, z, f2d, i);
	    PRINT3D (f3d, i);
	}

	/*
	** alle in wuerfel.h definierten Kanten werden ausgegeben
	*/
	for (j=1; j<=anzkanten; j++) {
	    PRINTSEGS (fsegs,kante,j);
	}

	/*
	** die Erzeugende Strecke des Oloids ausgeben
	** Es ist dies die Strecke: P1-P3-P17-P5
	*/
	for (j=1; j<=anzkoloid; j++) {
	    PRINTSEGS (foloid,koloid,j);
	}

	fprintf (f2dxy, "\n");
	fprintf (f2dxz, "\n");
	fprintf (f2dyz, "\n");
	fprintf (f3d,   "\n");
	fprintf (fsegs, "\n\n");
	fprintf (foloid, "\n\n");
    }
    fclose (f2dxy);
    fclose (f2dxz);
    fclose (f2dyz);
    fclose (f3d);
    fclose (fsegs);
    fclose (foloid);
}
